/*
 * PGRWetter.java
 *
 * Created on 3. Mrz 2008, 00:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/**
 *
 * @author Patrick Grochowy
 * PGR - Kommunikationsdesign
 * {@link http://www.grochowy.de}
 * @version 0.1
 */

package PGRWetter;

import java.awt.AWTException;
import java.awt.Image;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.SystemTray;
import java.awt.Toolkit;
import java.awt.TrayIcon;
import java.util.Calendar;
import java.util.Hashtable;
import java.util.TimeZone;
import java.util.Timer;
import java.util.TreeMap;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.prefs.BackingStoreException;
import java.util.prefs.Preferences;
import javax.swing.JOptionPane;
import javax.swing.JToolTip;


public class PGRWetter {
    public static String progName = Main.progName;
    public static String progVersion = Main.progVersion;
    
    private final Preferences prefStore = Preferences.userNodeForPackage(getClass());
    public int interval = prefStore.getInt("interval", 15);
    public int dispMode = prefStore.getInt("dispMode", 1);
    public int zenithMode = prefStore.getInt("zenithMode", 2);
    public String actStationID = prefStore.get("actStationID", "");
    public String actStationLat = prefStore.get("actStationLat", "");
    public String actStationLong = prefStore.get("actStationLong", "");
    public String actStationName = prefStore.get("actStationName", "");
    
    public static stationsWorker statWorker;
    
    private static Image cloudy1Icon = makeImage("/PGRWetter/icons/cloudy1.png");
    private static Image cloudy1_nightIcon = makeImage("/PGRWetter/icons/cloudy1_night.png");
    private static Image cloudy2Icon = makeImage("/PGRWetter/icons/cloudy2.png");
    private static Image cloudy2_nightIcon = makeImage("/PGRWetter/icons/cloudy2_night.png");
    private static Image cloudy3Icon = makeImage("/PGRWetter/icons/cloudy3.png");
    private static Image cloudy3_nightIcon = makeImage("/PGRWetter/icons/cloudy3_night.png");
    private static Image cloudy4Icon = makeImage("/PGRWetter/icons/cloudy4.png");
    private static Image cloudy4_nightIcon = makeImage("/PGRWetter/icons/cloudy4_night.png");
    private static Image cloudy5Icon = makeImage("/PGRWetter/icons/cloudy5.png");
    
    private static Image fogIcon = makeImage("/PGRWetter/icons/fog.png");
    private static Image fog_nightIcon = makeImage("/PGRWetter/icons/fog_night.png");
    
    private static Image hailIcon = makeImage("/PGRWetter/icons/hail.png");
    private static Image dunnoIcon = makeImage("/PGRWetter/icons/dunno.png");
    private static Image light_rainIcon = makeImage("/PGRWetter/icons/light_rain.png");
    private static Image mistIcon = makeImage("/PGRWetter/icons/mist.png");
    private static Image mist_nightIcon = makeImage("/PGRWetter/icons/mist_night.png");
    private static Image overcastIcon = makeImage("/PGRWetter/icons/overcast.png");
    
    private static Image shower1Icon = makeImage("/PGRWetter/icons/shower1.png");
    private static Image shower1_nightIcon = makeImage("/PGRWetter/icons/shower1_night.png");
    private static Image shower2Icon = makeImage("/PGRWetter/icons/shower2.png");
    private static Image shower2_nightIcon = makeImage("/PGRWetter/icons/shower2_night.png");
    private static Image shower3Icon = makeImage("/PGRWetter/icons/shower3.png");
    
    private static Image sleetIcon = makeImage("/PGRWetter/icons/sleet.png");
    
    private static Image snow1Icon = makeImage("/PGRWetter/icons/snow1.png");
    private static Image snow1_nightIcon = makeImage("/PGRWetter/icons/snow1_night.png");
    private static Image snow2Icon = makeImage("/PGRWetter/icons/snow2.png");
    private static Image snow2_nightIcon = makeImage("/PGRWetter/icons/snow2_night.png");
    private static Image snow3Icon = makeImage("/PGRWetter/icons/snow3.png");
    private static Image snow3_nightIcon = makeImage("/PGRWetter/icons/snow3_night.png");
    private static Image snow4Icon = makeImage("/PGRWetter/icons/snow4.png");
    private static Image snow5Icon = makeImage("/PGRWetter/icons/snow5.png");
    
    private static Image sunnyIcon = makeImage("/PGRWetter/icons/sunny.png");
    private static Image sunny_nightIcon = makeImage("/PGRWetter/icons/sunny_night.png");
    
    private static Image tstorm1Icon = makeImage("/PGRWetter/icons/tstorm1.png");
    private static Image tstorm1_nightIcon = makeImage("/PGRWetter/icons/tstorm1_night.png");
    private static Image tstorm2Icon = makeImage("/PGRWetter/icons/tstorm2.png");
    private static Image tstorm2_nightIcon = makeImage("/PGRWetter/icons/tstorm2_night.png");
    private static Image tstorm3Icon = makeImage("/PGRWetter/icons/tstorm3.png");
    
    public static final Hashtable<String, Image> iconsHashTable = new Hashtable<String, Image>();
    
    public static TrayIcon traySymbol = null;
    
    private static trayListener listener = null;
    private static PopupMenu popup = new PopupMenu();
    
    public static TreeMap stationsMap = null;
    
    public static final String metarStationsString = "http://weather.noaa.gov/pub/data/observations/metar/stations/";
    public static final String metarDecodedString = "http://weather.noaa.gov/pub/data/observations/metar/decoded/";
    
    public static Calendar actInfo_DateCal = Calendar.getInstance();
    public static Vector<String> actInfo_CurrentVect = new Vector<String>();
    public static Vector<String> actInfo_CoverVect = new Vector<String>();
    public static String actInfo_WindSpeedString = "";
    public static String actInfo_WindDirectionString = "";
    public static String actInfo_VisibilityString = "";
    public static String actInfo_PressureString = "";
    public static String actInfo_RelHumidityString = "";
    public static String actInfo_TemperatureString = "";
    public static String actInfo_DewPointString = "";
    public static String actInfo_HeatIndexString = "";
    public static String actInfo_WindChillString = "";
    public static String actInfo_TheWeatherString = "";
    public static String actInfo_sunRiseString = "";
    public static String actInfo_sunSetString = "";
    public static String actInfo_DecodedString = "";
    
    public static Timer timer;
    public static UpdateTimer updateTrayTimer;
    public static infosJFrame infosFrame;
    public boolean isUpdating = true;
    public boolean offline = false;
    
    /** Creates a new instance of PGRWetter */
    public PGRWetter() {
	statWorker = new stationsWorker(this);
	actInfo_DateCal.setTimeZone(TimeZone.getTimeZone("Etc/UTC"));
	listener = new trayListener(this);
	makeMenu();
	
	iconsHashTable.put("cloudy1", cloudy1Icon);
	iconsHashTable.put("cloudy1_night", cloudy1_nightIcon);
	iconsHashTable.put("cloudy2", cloudy2Icon);
	iconsHashTable.put("cloudy2_night", cloudy2_nightIcon);
	iconsHashTable.put("cloudy3", cloudy3Icon);
	iconsHashTable.put("cloudy3_night", cloudy3_nightIcon);
	iconsHashTable.put("cloudy4", cloudy4Icon);
	iconsHashTable.put("cloudy4_night", cloudy4_nightIcon);
	iconsHashTable.put("cloudy5", cloudy5Icon);
	iconsHashTable.put("fog", fogIcon);
	iconsHashTable.put("fog_night", fog_nightIcon);
	iconsHashTable.put("hail", hailIcon);
	iconsHashTable.put("dunno", dunnoIcon);
	iconsHashTable.put("light_rain", light_rainIcon);
	iconsHashTable.put("mist", mistIcon);
	iconsHashTable.put("mist_night", mist_nightIcon);
	iconsHashTable.put("overcast", overcastIcon);
	iconsHashTable.put("shower1", shower1Icon);
	iconsHashTable.put("shower1_night", shower1_nightIcon);
	iconsHashTable.put("shower2", shower2Icon);
	iconsHashTable.put("shower2_night", shower2_nightIcon);
	iconsHashTable.put("shower3", shower3Icon);
	iconsHashTable.put("sleet", sleetIcon);
	iconsHashTable.put("snow1", snow1Icon);
	iconsHashTable.put("snow1_night", snow1_nightIcon);
	iconsHashTable.put("snow2", snow2Icon);
	iconsHashTable.put("snow2_night", snow2_nightIcon);
	iconsHashTable.put("snow3", snow3Icon);
	iconsHashTable.put("snow3_night", snow3_nightIcon);
	iconsHashTable.put("snow4", snow4Icon);
	iconsHashTable.put("snow5", snow5Icon);
	iconsHashTable.put("sunny", sunnyIcon);
	iconsHashTable.put("sunny_night", sunny_nightIcon);
	iconsHashTable.put("tstorm1", tstorm1Icon);
	iconsHashTable.put("tstorm1_night", tstorm1_nightIcon);
	iconsHashTable.put("tstorm2", tstorm2Icon);
	iconsHashTable.put("tstorm2_night", tstorm2_nightIcon);
	iconsHashTable.put("tstorm3", tstorm3Icon);
	
	initTray( SystemTray.getSystemTray() );
	stationsMap = statWorker.getStationsMap();
	
	infosFrame = new infosJFrame(this);
	
	if(!actStationID.equals("")){
	    timer = new Timer();
	    updateTrayTimer = new UpdateTimer(this);
	    timer.scheduleAtFixedRate(updateTrayTimer, 0, interval * 60000);
	} else {
	    timer = new Timer();
	    updateTrayTimer = new UpdateTimer(this);
	    String toolTipText = progName + " " + progVersion + "\n" +
		    "erster Start ...\n" +
		    "bereite Konfigurationsdialog vor ...";
	    traySymbol.setToolTip(toolTipText);
	    showConfig();
	}
    }
    
    public void showInfos() {
	//infosJFrame infosFrame = new infosJFrame(newMain);
	infosFrame.updateAllInfos();
	infosFrame.setLocationRelativeTo(null);
	infosFrame.setVisible(true);
    }
    
    public void showConfig() {
	configJFrame configFrame = new configJFrame(this);
	configFrame.setLocationRelativeTo(null);
	configFrame.setVisible(true);
    }
    
    public void showAbout() {
	aboutJFrame aboutFrame = new aboutJFrame();
	aboutFrame.setLocationRelativeTo(null);
	aboutFrame.setVisible(true);
    }
    
    public void exit() {
	storePreferences();
	//try { prefStore.clear(); } catch (BackingStoreException ex) { ex.printStackTrace(); }
	System.exit(0);
    }
    
    @SuppressWarnings("static-access")
    public synchronized void updateTray() {
	isUpdating = true;
	statWorker.zenithModeInt = zenithMode;
	statWorker.actStationLat = actStationLat;
	statWorker.actStationLong = actStationLong;
	
	//System.out.println("\n### updateTray() (" + new SimpleDateFormat("HH:mm:ss").format(new Date(System.currentTimeMillis())) + ") ###");
	
	// die Daten aktualisieren
	statWorker.updateAllWeatherInfos(actStationID);
	//printDebugVars();
	
	//System.out.println("### offline: " + offline + " ###");	
	if(offline){
	   actInfo_TheWeatherString = "dunno";
	}	
	traySymbol.setImage(iconsHashTable.get(actInfo_TheWeatherString));	
	String toolTipText = progName + " " + progVersion + "\n" + actStationName;
	if(dispMode == 2){
	    toolTipText += "\nTemperatur: " + actInfo_TemperatureString;
	} else if(dispMode == 3){
	    toolTipText += "\nTemperatur: " + actInfo_TemperatureString + "\n" +
		    "Wind: " + actInfo_WindSpeedString + " " + actInfo_WindDirectionString + "\n" +
		    "Luftdruck: " + actInfo_PressureString;
	}
	if(!offline){
	traySymbol.setToolTip(toolTipText);
	} else {
	    traySymbol.setToolTip(progName + " " + progVersion + "\n" + 
		    actStationName + "\n" + "keine Daten. Computer offline.");
	}
	
	isUpdating = false;
    }
    
    private static final void printDebugVars(){
	System.out.println("");
	System.out.println("### --- printDebugVars --- ###");
	System.out.println("### actInfo_DateCal: " + actInfo_DateCal.getTime().toString() + " ###");
	System.out.println("### actInfo_CurrentVect: " + actInfo_CurrentVect + " ###");
	System.out.println("### actInfo_CoverVect: " + actInfo_CoverVect + " ###");
	System.out.println("### actInfo_WindSpeedString: " + actInfo_WindSpeedString + " ###");
	System.out.println("### actInfo_WindDirectionString: " + actInfo_WindDirectionString + " ###");
	System.out.println("### actInfo_VisibilityString: " + actInfo_VisibilityString + " ###");
	System.out.println("### actInfo_PressureString: " + actInfo_PressureString + " ###");
	System.out.println("### actInfo_RelHumidityString: " + actInfo_RelHumidityString + " ###");
	System.out.println("### actInfo_TemperatureString: " + actInfo_TemperatureString + " ###");
	System.out.println("### actInfo_DewPointString: " + actInfo_DewPointString + " ###");
	System.out.println("### actInfo_HeatIndexString: " + actInfo_HeatIndexString + " ###");
	System.out.println("### actInfo_WindChillString: " + actInfo_WindChillString + " ###");
	System.out.println("### actInfo_TheWeatherString: " + actInfo_TheWeatherString + " ###");
	System.out.println("### actInfo_sunRiseString: " + actInfo_sunRiseString + " ###");
	System.out.println("### actInfo_sunSetString: " + actInfo_sunSetString + " ###");
	System.out.println("### actInfo_DecodedString:\n" + actInfo_DecodedString);
	//System.out.println("### actInfo_StationNameString: " + actInfo_StationNameString + " ###");
    }
    
    private static synchronized void initTray(SystemTray tray) {
	traySymbol = new TrayIcon(iconsHashTable.get("dunno"), "", popup) {
	    public JToolTip createToolTip(){ return new JMultiLineToolTip(); }
	};
	traySymbol.setImageAutoSize(true);
	traySymbol.addActionListener(listener);
	traySymbol.addMouseListener(listener);
	traySymbol.setToolTip(progName + " " + progVersion + ":" + " suche Daten ...");
	
	try {
	    tray.add(traySymbol);
	} catch (AWTException e) {
	    System.err.println(e);
	    JOptionPane.showMessageDialog(null, e.toString(), "AWTException", JOptionPane.ERROR_MESSAGE);
	}
    }
    
    private static void makeMenu() {
	MenuItem titleItem = new MenuItem(progName + " " + progVersion);
	MenuItem sep1Item = new MenuItem("-");
	MenuItem showItem = new MenuItem("Daten anzeigen");
	MenuItem configItem = new MenuItem("Konfiguration");
	MenuItem sep2Item = new MenuItem("-");
	MenuItem updateItem = new MenuItem("Daten aktualisieren");
	MenuItem sep3Item = new MenuItem("-");
	MenuItem aboutItem = new MenuItem("ber");
	MenuItem exitItem = new MenuItem("Beenden");
	
	titleItem.setEnabled(false);
	
	showItem.addActionListener(listener);
	configItem.addActionListener(listener);
	updateItem.addActionListener(listener);
	aboutItem.addActionListener(listener);
	exitItem.addActionListener(listener);
	
	popup.add(titleItem);
	popup.add(sep1Item);
	popup.add(showItem);
	popup.add(configItem);
	popup.add(sep2Item);
	popup.add(updateItem);
	popup.add(sep3Item);
	popup.add(aboutItem);
	popup.add(exitItem);
    }
    
    public synchronized void storePreferences() {
	prefStore.put("actStationID", actStationID);
	prefStore.putInt("interval", interval);
	prefStore.putInt("dispMode", dispMode);
	prefStore.putInt("zenithMode", zenithMode);
	prefStore.put("actStationLat", actStationLat);
	prefStore.put("actStationLong", actStationLong);
	prefStore.put("actStationName", actStationName);
        try {
            prefStore.flush();
        } catch (BackingStoreException ex) {
            Logger.getLogger(PGRWetter.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
    
    private static Image makeImage(String imgString) {
	return Toolkit.getDefaultToolkit().getImage( Main.class.getResource( imgString ) );
    }
    
    @SuppressWarnings("static-access")
    public synchronized void upDateLongLat() {
	//System.out.println("#### upDateLongLat() ####");
	isUpdating = true;
	String[] latLongArray = statWorker.updateLongLatVals(actStationID);
	actStationLat = latLongArray[0];
	actStationLong = latLongArray[1];
	actStationName = latLongArray[2];
	statWorker.actStationLat = actStationLat;
	statWorker.actStationLong = actStationLong;
	isUpdating = false;
    }
    
    void resetTimer() {
	timer.cancel();
	updateTrayTimer.cancel();
	timer = new Timer();
	updateTrayTimer = new UpdateTimer(this);
	timer.scheduleAtFixedRate(updateTrayTimer, 0, interval * 60000);
    }
}
