/*
 * configJFrame.java
 *
 * Created on 25. Februar 2008, 04:24
 */

package PGRWetter;

import java.awt.Toolkit;
import java.text.SimpleDateFormat;
import java.util.Iterator;
import java.util.TimeZone;
import javax.swing.ImageIcon;
import javax.swing.JFrame;

/**
 *
 * @author  paddy
 */
public class infosJFrame extends JFrame {
    
    PGRWetter pgrWetter;
    private static int newDispMode = 1;
    private static SimpleDateFormat sdfUTC = new SimpleDateFormat("EEE, dd.MM.yyyy HH:mm 'Uhr' z");
    private static SimpleDateFormat sdfLocal = new SimpleDateFormat("dd.MM.yyyy HH:mm z");
    
    /** Creates new form configJFrame
     * @param pgrWetter
     */
    public infosJFrame(PGRWetter pgrWetter) {
	this.pgrWetter = pgrWetter;
	sdfUTC.setTimeZone(TimeZone.getTimeZone("Etc/UTC"));
	sdfLocal.setTimeZone(TimeZone.getDefault());
	initComponents();
	setIconImage(Toolkit.getDefaultToolkit().getImage((getClass().getResource("pgr_ico.png"))));
	if(!pgrWetter.isUpdating){
	    updateAllInfos();
	    this.validate();
	}
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabelTitel = new javax.swing.JLabel();
        jLabelDatum = new javax.swing.JLabel();
        jLabelIconHolder = new javax.swing.JLabel();
        jScrollPaneCoverCurrent = new javax.swing.JScrollPane();
        jTextPaneCoverCurrent = new javax.swing.JTextPane();
        jLabelMetarTitle = new javax.swing.JLabel();
        jScrollPaneMetar = new javax.swing.JScrollPane();
        jTextPaneMetar = new javax.swing.JTextPane();
        jLabelTempLabel = new javax.swing.JLabel();
        jLabelDewLabel = new javax.swing.JLabel();
        jLabelChillLabel = new javax.swing.JLabel();
        jLabelWindLabel = new javax.swing.JLabel();
        jLabelHumidLabel = new javax.swing.JLabel();
        jLabelPressLabel = new javax.swing.JLabel();
        jLabelSunRiseLabel = new javax.swing.JLabel();
        jLabelSunSetLabel = new javax.swing.JLabel();
        jLabelTemp = new javax.swing.JLabel();
        jLabelDew = new javax.swing.JLabel();
        jLabelChill = new javax.swing.JLabel();
        jLabelWind = new javax.swing.JLabel();
        jLabelHumid = new javax.swing.JLabel();
        jLabelPress = new javax.swing.JLabel();
        jLabelSunRise = new javax.swing.JLabel();
        jLabelSunSet = new javax.swing.JLabel();
        jLabelVisibLabel = new javax.swing.JLabel();
        jLabelVisib = new javax.swing.JLabel();
        jLabelHeatIndexLabel = new javax.swing.JLabel();
        jLabelHeatIndex = new javax.swing.JLabel();
        jButtonOk = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("PGR-Wetter: Wetterinfos");
        setBackground(javax.swing.UIManager.getDefaults().getColor("nbProgressBar.popupText.background"));
        jLabelTitel.setBackground(new java.awt.Color(255, 183, 0));
        jLabelTitel.setFont(new java.awt.Font("Tahoma", 1, 16));
        jLabelTitel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelTitel.setText("Wetterinfos");
        jLabelTitel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabelTitel.setOpaque(true);
        jLabelTitel.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jLabelDatum.setBackground(new java.awt.Color(255, 255, 255));
        jLabelDatum.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabelDatum.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelDatum.setText("Zuletzt aktualisiert");
        jLabelDatum.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabelDatum.setOpaque(true);

        jLabelIconHolder.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PGRWetter/icons/dunno.png")));
        jLabelIconHolder.setToolTipText("keine Infos");

        jScrollPaneCoverCurrent.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPaneCoverCurrent.setBorder(null);
        jScrollPaneCoverCurrent.setOpaque(false);
        jTextPaneCoverCurrent.setBorder(null);
        jTextPaneCoverCurrent.setEditable(false);
        jTextPaneCoverCurrent.setOpaque(false);
        jScrollPaneCoverCurrent.setViewportView(jTextPaneCoverCurrent);

        jLabelMetarTitle.setFont(new java.awt.Font("Tahoma", 2, 10));
        jLabelMetarTitle.setForeground(javax.swing.UIManager.getDefaults().getColor("controlDkShadow"));
        jLabelMetarTitle.setLabelFor(jScrollPaneMetar);
        jLabelMetarTitle.setText(" METAR Infos:");
        jLabelMetarTitle.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabelMetarTitle.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jTextPaneMetar.setEditable(false);
        jTextPaneMetar.setFont(new java.awt.Font("Serif", 0, 11));
        jScrollPaneMetar.setViewportView(jTextPaneMetar);

        jLabelTempLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelTempLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelTempLabel.setLabelFor(jLabelTemp);
        jLabelTempLabel.setText("Temperatur:");
        jLabelTempLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelTempLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelTempLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelDewLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelDewLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelDewLabel.setLabelFor(jLabelDew);
        jLabelDewLabel.setText("Taupunkt:");
        jLabelDewLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelDewLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelDewLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelChillLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelChillLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelChillLabel.setLabelFor(jLabelChill);
        jLabelChillLabel.setText("gef\u00fchlte Temperatur:");
        jLabelChillLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelChillLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelChillLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelWindLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelWindLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelWindLabel.setLabelFor(jLabelWind);
        jLabelWindLabel.setText("Windgeschwindigkeit:");

        jLabelHumidLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelHumidLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelHumidLabel.setLabelFor(jLabelHumid);
        jLabelHumidLabel.setText("rel. Luftfeuchtigkeit:");
        jLabelHumidLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelHumidLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelHumidLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelPressLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelPressLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelPressLabel.setLabelFor(jLabelPress);
        jLabelPressLabel.setText("Luftdruck:");
        jLabelPressLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelPressLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelPressLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelSunRiseLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelSunRiseLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelSunRiseLabel.setLabelFor(jLabelSunRise);
        jLabelSunRiseLabel.setText("Sonnenaufgang:");
        jLabelSunRiseLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelSunRiseLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelSunRiseLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelSunSetLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelSunSetLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelSunSetLabel.setLabelFor(jLabelSunSet);
        jLabelSunSetLabel.setText("Sonnenuntergang:");
        jLabelSunSetLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelSunSetLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelSunSetLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelTemp.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelTemp.setText("jLabelTemp");

        jLabelDew.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelDew.setText("jLabelDew");

        jLabelChill.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelChill.setText("jLabelChill");

        jLabelWind.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelWind.setText("jLabelWind");

        jLabelHumid.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelHumid.setText("jLabelHumid");

        jLabelPress.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelPress.setText("jLabelPress");

        jLabelSunRise.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelSunRise.setText("jLabelSunRise");

        jLabelSunSet.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelSunSet.setText("jLabelSunSet");

        jLabelVisibLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelVisibLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelVisibLabel.setLabelFor(jLabelVisib);
        jLabelVisibLabel.setText("Sichtweite:");
        jLabelVisibLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelVisibLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelVisibLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelVisib.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelVisib.setText("jLabelVisib");

        jLabelHeatIndexLabel.setFont(new java.awt.Font("SansSerif", 1, 11));
        jLabelHeatIndexLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelHeatIndexLabel.setLabelFor(jLabelHeatIndex);
        jLabelHeatIndexLabel.setText("Hitzeindex:");
        jLabelHeatIndexLabel.setMaximumSize(new java.awt.Dimension(124, 14));
        jLabelHeatIndexLabel.setMinimumSize(new java.awt.Dimension(124, 14));
        jLabelHeatIndexLabel.setPreferredSize(new java.awt.Dimension(124, 14));

        jLabelHeatIndex.setFont(new java.awt.Font("SansSerif", 0, 11));
        jLabelHeatIndex.setText("jLabelHeatIndex");

        jButtonOk.setText("OK");
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOkActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelTitel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE)
                    .addComponent(jLabelDatum, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPaneMetar, javax.swing.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabelTempLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelDewLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelChillLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelHeatIndexLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelWindLabel)
                            .addComponent(jLabelHumidLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelPressLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelVisibLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelSunRiseLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelSunSetLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonOk)
                            .addComponent(jLabelSunSet, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelSunRise, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelVisib, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelPress, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelHumid, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelWind, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelHeatIndex, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelChill, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelDew, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabelTemp, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabelIconHolder)
                            .addComponent(jLabelMetarTitle))
                        .addGap(15, 15, 15)
                        .addComponent(jScrollPaneCoverCurrent, javax.swing.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabelChillLabel, jLabelDewLabel, jLabelHeatIndexLabel, jLabelHumidLabel, jLabelPressLabel, jLabelSunRiseLabel, jLabelSunSetLabel, jLabelTempLabel, jLabelVisibLabel, jLabelWindLabel});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelTitel, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(jLabelDatum, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabelIconHolder)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                        .addComponent(jLabelMetarTitle))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPaneCoverCurrent, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPaneMetar, javax.swing.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelTemp)
                            .addComponent(jLabelTempLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelDew)
                            .addComponent(jLabelDewLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelChill)
                            .addComponent(jLabelChillLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelHeatIndex)
                            .addComponent(jLabelHeatIndexLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelWind)
                            .addComponent(jLabelWindLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelHumid)
                            .addComponent(jLabelHumidLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelPress)
                            .addComponent(jLabelPressLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelVisib)
                            .addComponent(jLabelVisibLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelSunRise)
                            .addComponent(jLabelSunRiseLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelSunSet)
                            .addComponent(jLabelSunSetLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 37, Short.MAX_VALUE)
                        .addComponent(jButtonOk)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabelChillLabel, jLabelDewLabel, jLabelHeatIndexLabel, jLabelHumidLabel, jLabelPressLabel, jLabelSunRiseLabel, jLabelSunSetLabel, jLabelTempLabel, jLabelVisibLabel, jLabelWindLabel});

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabelChill, jLabelDew, jLabelHeatIndex, jLabelHumid, jLabelPress, jLabelSunRise, jLabelSunSet, jLabelTemp, jLabelVisib, jLabelWind});

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void jButtonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOkActionPerformed
	//this.dispose();
	this.setVisible(false);
    }//GEN-LAST:event_jButtonOkActionPerformed
    
    public void updateAllInfos(){
	if(!pgrWetter.isUpdating){
	    fillTitle();
	    fillIcon();
	    fillCoverCurrent();
	    fillInfoVals();
	    fillMetarInfoPane();
	}
    }
    
    @SuppressWarnings("static-access")
    private void fillTitle() {
	jLabelTitel.setText("Wetterstation: " + pgrWetter.actStationName);
	//jLabelDatum.setText("Zuletzt aktualisiert am " + pgrWetter.actInfo_DateCal.getTime().toString());
	if(!pgrWetter.offline){
	    jLabelDatum.setText( "Stand: " +
		    sdfUTC.format(pgrWetter.actInfo_DateCal.getTime()) +
		    " (" +
		    sdfLocal.format(pgrWetter.actInfo_DateCal.getTime()) + ")");
	    this.setTitle("PGR-Wetter: " + pgrWetter.actStationName);
	} else {
	    jLabelDatum.setText( "Stand: keine Daten. Computer Offline" );
	    this.setTitle("PGR-Wetter: keine Daten. Computer Offline");
	}
    }
    
    @SuppressWarnings("static-access")
    private void fillIcon() {
	if(this.jLabelIconHolder != null){
	    jLabelIconHolder.setIcon(null);
	    if( !pgrWetter.iconsHashTable.isEmpty() && !pgrWetter.actInfo_TheWeatherString.isEmpty() ){
		jLabelIconHolder.setIcon(new ImageIcon( pgrWetter.iconsHashTable.get(pgrWetter.actInfo_TheWeatherString) ) );
		jLabelIconHolder.setToolTipText(pgrWetter.actInfo_TheWeatherString);
	    }
	}
    }
    
    @SuppressWarnings("static-access")
    private void fillMetarInfoPane() {
	String infoLink = pgrWetter.metarDecodedString + pgrWetter.actStationID + ".TXT";
	jTextPaneMetar.setText(pgrWetter.actInfo_DecodedString);
	jTextPaneMetar.setToolTipText(infoLink);
    }
    
    @SuppressWarnings("static-access")
    private void fillCoverCurrent() {
	//System.out.println("+++ fillCoverCurrent() +++");
	jTextPaneCoverCurrent.setText("");
	String CoverCurrentText = "";
	if(!pgrWetter.offline){
	    Iterator curIter = pgrWetter.actInfo_CurrentVect.iterator();
	    while(curIter.hasNext()){
		CoverCurrentText = jTextPaneCoverCurrent.getText();
		//CoverCurrentText += "\u00b7 " + curIter.next().toString() + "\n";
		CoverCurrentText += "\u2022 " + curIter.next().toString() + "\n";
		jTextPaneCoverCurrent.setText(CoverCurrentText);
	    }
	    
	    Iterator covIter = pgrWetter.actInfo_CoverVect.iterator();
	    while(covIter.hasNext()){
		CoverCurrentText = jTextPaneCoverCurrent.getText();
		//CoverCurrentText += "\u00b7 " + covIter.next().toString() + "\n";
		CoverCurrentText += "\u2022 " + covIter.next().toString() + "\n";
		jTextPaneCoverCurrent.setText(CoverCurrentText);
	    }
	} else {
	    jTextPaneCoverCurrent.setText("\u2022 keine Daten. Computer offline");
	}
    }
    
    @SuppressWarnings("static-access")
    private void fillInfoVals() {
	jLabelTemp.setText(pgrWetter.actInfo_TemperatureString);
	jLabelDew.setText(pgrWetter.actInfo_DewPointString);
	jLabelChill.setText(pgrWetter.actInfo_WindChillString);
	jLabelHeatIndex.setText(pgrWetter.actInfo_HeatIndexString);
	
	jLabelWind.setText(pgrWetter.actInfo_WindSpeedString + ", " + pgrWetter.actInfo_WindDirectionString);
	jLabelHumid.setText(pgrWetter.actInfo_RelHumidityString);
	jLabelPress.setText(pgrWetter.actInfo_PressureString);
	
	jLabelVisib.setText(pgrWetter.actInfo_VisibilityString);
	
	jLabelSunRise.setText(pgrWetter.actInfo_sunRiseString);
	jLabelSunSet.setText(pgrWetter.actInfo_sunSetString);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOk;
    private javax.swing.JLabel jLabelChill;
    private javax.swing.JLabel jLabelChillLabel;
    private javax.swing.JLabel jLabelDatum;
    private javax.swing.JLabel jLabelDew;
    private javax.swing.JLabel jLabelDewLabel;
    private javax.swing.JLabel jLabelHeatIndex;
    private javax.swing.JLabel jLabelHeatIndexLabel;
    private javax.swing.JLabel jLabelHumid;
    private javax.swing.JLabel jLabelHumidLabel;
    private javax.swing.JLabel jLabelIconHolder;
    private javax.swing.JLabel jLabelMetarTitle;
    private javax.swing.JLabel jLabelPress;
    private javax.swing.JLabel jLabelPressLabel;
    private javax.swing.JLabel jLabelSunRise;
    private javax.swing.JLabel jLabelSunRiseLabel;
    private javax.swing.JLabel jLabelSunSet;
    private javax.swing.JLabel jLabelSunSetLabel;
    private javax.swing.JLabel jLabelTemp;
    private javax.swing.JLabel jLabelTempLabel;
    private javax.swing.JLabel jLabelTitel;
    private javax.swing.JLabel jLabelVisib;
    private javax.swing.JLabel jLabelVisibLabel;
    private javax.swing.JLabel jLabelWind;
    private javax.swing.JLabel jLabelWindLabel;
    private javax.swing.JScrollPane jScrollPaneCoverCurrent;
    private javax.swing.JScrollPane jScrollPaneMetar;
    private javax.swing.JTextPane jTextPaneCoverCurrent;
    private javax.swing.JTextPane jTextPaneMetar;
    // End of variables declaration//GEN-END:variables
    
}
